local name = 'hidden-pole-1x1'
local type = 'lamp'

function on_built (entity)
--	create_entity{name=…, position=…, direction=…, force=…, target=…, source=…, fast_replace=…, player=…, spill=…, raise_built=…, create_build_effect_smoke=…, spawn_decorations=…}
	local surface = entity.surface
	local position = entity.position
	local force = entity.force
	if not (entity.is_connected_to_electric_network()) then
		local pole = surface.create_entity{name=name, position=position, force=force}
		local neighbours = pole.neighbours
		if neighbours then
--			game.print ('neighbours: ' .. serpent.line (neighbours))
--			game.print ('neighbours: ' .. serpent.line (neighbours.copper))
			for i, target in pairs (neighbours.copper) do
--				game.print ('n: ' .. n.name)
				if target.name == name then
					local poles = target.neighbours.copper
					pole.disconnect_neighbour(target)
					for i, p in pairs (poles) do
						if not (p.name == name) then
							game.print (p.name)
							pole.connect_neighbour(p)
						end
					end
				end
			end
		end
	--	game.print ('created')
	end

end


script.on_event(defines.events.on_built_entity, function(event)
  local entity = event.created_entity
  if entity and entity.type == type then
      on_built (entity)
  end
end)


script.on_event(defines.events.on_robot_built_entity, function(event)
  local entity = event.created_entity
  if entity and entity.type == type then
	 on_built (entity)
  end
end)


function on_remove (entity)
	local surface = entity.surface
	local position = entity.position
	local pole = surface.find_entity(name, position)
	if pole then 
		pole.destroy()
--		game.print ('destroyed')
	end
end

script.on_event(defines.events.on_entity_died, function(event) 
	local entity = event.entity
	if entity and entity.type == type then
		on_remove (entity)
	end	
end)

script.on_event(defines.events.on_player_mined_entity, function(event) 
	local entity = event.entity
	if entity and entity.type == type then
		on_remove (entity)
	end	
end)

script.on_event(defines.events.on_robot_mined, function(event) 
	local entity = event.entity
	if entity and entity.type == type then
		on_remove (entity)
	end	
end)
